<?php
// $Id$

/**
 * @file
 * Theme Functions - Set site to offline mode
 *
 * @author: Daniel Honrade http://drupal.org/user/351112
 *
 */
 
/**
 * Additional Meta from Info file
 *
 */
function om_offline(&$vars, $info) { 
  global $user;
  $om_path = OM_BASE_THEME_PATH;
  
  if (isset($info['settings']['offline']['switch']) && ($info['settings']['offline']['switch'] == 'on') && ($user->uid == 0)) {

    $today   = getdate();
    $year    = (isset($info['settings']['countdown']['year']) && !empty($info['settings']['countdown']['year'])) ? $info['settings']['countdown']['year']: $today['year'];
    $month   = (isset($info['settings']['countdown']['month']) && !empty($info['settings']['countdown']['month'])) ? $info['settings']['countdown']['month']: 1;
    $days    = (isset($info['settings']['countdown']['days']) && !empty($info['settings']['countdown']['days'])) ? $info['settings']['countdown']['days']: 1;      
    $hours   = (isset($info['settings']['countdown']['hours']) && !empty($info['settings']['countdown']['hours'])) ? $info['settings']['countdown']['hours']: 1;      
    $minutes = (isset($info['settings']['countdown']['minutes']) && !empty($info['settings']['countdown']['minutes'])) ? $info['settings']['countdown']['minutes']: 1;      
    $seconds = (isset($info['settings']['countdown']['seconds']) && !empty($info['settings']['countdown']['seconds'])) ? $info['settings']['countdown']['seconds']: 1;      
            
    // hour, minute, second, month, day, year
    $now = (($today['year'] * 12 * 30 * 24 * 60 * 60) + ($today['mon'] * 30 * 24 * 60 * 60) + ($today['mday'] * 24 * 60 * 60)) + (($today['hours'] * 24 * 60 * 60) + ($today['minutes'] * 60 ) + $today['seconds']);
    //print $today['year'] . ' ' .  ($today['mon'] * 30) . ' ' . $today['mday'] . ' ' . ($today['hours'] * 24 * 60 * 60) . ' ' . ($today['minutes'] * 60) . ' ' . $today['seconds'] . '<br />';
    //print $now . '<br />';
    $settings_time = (($year * 12 * 30 * 24 * 60 * 60) + ($month * 30 * 24 * 60 * 60) + ($days * 24 * 60 * 60)) + (($hours * 24 * 60 * 60) + ($minutes * 60) + $seconds);
    //print $year . ' ' .  ($month * 30) . ' ' . $days . ' ' . ($hours * 24 * 60 * 60) . ' ' . ($minutes * 60) . ' ' . $seconds . '<br />';
    //print $settings_time;
    
    if ($now < $settings_time) {
      $vars['footer_region'] = om_offline_content($vars, $info);

      $countdown = '';
      $countdown .= 'jQuery(document).ready(function ($) {';
      $countdown .= '  var onlineDay = new Date(' . $year . ', ' . $month . '-1, ' . $days . ', ' . $hours . ', ' . $minutes . ', ' . $seconds . ');'; 

      $countdown .= '	 $("#om-launch-content #om-launch-counter").countdown({until: onlineDay, onExpiry: launch, alwaysExpire: true});';
      $countdown .= '	 $("body").prepend($("#om-launch-content"));';
      $countdown .= '	 $(".wrapper-outer").remove();';
      $countdown .= '	 function launch() { document.location.href = ""; };';
      $countdown .= '});';
      drupal_add_js($om_path . '/js/jquery.countdown.js'); 
      drupal_add_js($countdown, "inline"); 
      drupal_add_css($om_path . '/css/om_offline.css', array('group' => CSS_THEME));       
    } 
  }
}


/**
 * OM Offline Screen
 * 
 * - Logo
 * - Site Name
 * - Message
 * - Login
 *
 */
function om_offline_content(&$vars, $info) { 
  global $theme_path;
  $login_form = drupal_get_form('user_login');
  $out = '<div id="om-launch-content">';
  $out .= '<div id="logo"><a href="' . $vars['front_page'] . '" title="' . t('Home') . '" rel="home"><img src="' . $theme_path . '/logo.png" alt="' . t('Home') . '" /></a></div>';
  $out .= '<h1 id="site-name"><a href="' . $vars['front_page'] . '" title="' . t('Home') . '" rel="home">' . $vars['site_name'] . '</a></h1>';
  $out .= '<p>' . $info['settings']['offline']['message'] . ' ' . $vars['feed_icons'] . '</p>'; 
  $out .= '<div id="om-launch-counter"></div>';
  $out .= drupal_render($login_form);
  $out .= '</div>';
  
  return $out;
} 
